//
//  RubiksCube.java
//
//  Created by Thomas Jannaud on 09/08/08.
//  Copyright 2008 Jannaud's Technical Company ©. All rights reserved.
//

// La classe Cube implémente le cube proprement dit, et elle le dessine.
// la classe Viewer est en quelque sorte la caméra : c'est elle qui projette l'image 3D abstraite en des points 2D
// La classe Rubikscube (ici) ne sert pas à grand chose, à part à créer tout le bazar

import java.awt.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;

public class RubiksCube extends JApplet implements MouseListener, MouseMotionListener {
	Image imgTmp;
	Graphics img_g;
	Cube cub;
	Viewer camera;
	int lastX = -1, lastY = -1;
	
	public void init() {
		Cube.initialiser();
		cub = new Cube(getParameter("debut"));
//		cub = new Cube("1BBLOOJVROJVRBLLRVVJJO");
		camera = new Viewer_Oeil();
		imgTmp = createImage(150, 200);
		img_g = imgTmp.getGraphics();
		addMouseMotionListener(this);
		addMouseListener(this);
	}
	
	public void update(Graphics g) {
		paint(g);
	}
	public void paint (Graphics g) {
		super.paint(g);
		cub.dessiner(img_g, camera);
		g.drawImage(imgTmp, 0, 0, this);
	}
	
	public void mousePressed(MouseEvent event) {
		lastX = event.getX();
		lastY = event.getY();
	}
	public void mouseDragged(MouseEvent event) {
		int x = event.getX();
		int y = event.getY();
		
		synchronized (imgTmp) { // histoire de ne pas recréer plusieurs images en même temps à cause de mouvements rapides.
			// synchronized utilise le mécanisme des "sémaphores". cf Wikipédia.
			camera.moveCamera(lastX - x, y - lastY);
			lastX = x;
			lastY = y;
		}
		
		repaint();
	}
	public void mouseReleased(MouseEvent event) {} // obligés d'être implémenté
	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}
	
}
